SystemOrganization addCategory: #'Animations-Core'!
SystemOrganization addCategory: #'Animations-Tests'!
SystemOrganization addCategory: #'Animations-Canvas'!
SystemOrganization addCategory: #'Animations-Animations'!

!Canvas methodsFor: '*animations-core' stamp: 'mt 5/17/2010 16:35:57.946'!
originalCanvas

	^ self! !

!Morph methodsFor: '*animations-core' stamp: 'mt 4/22/2011 11:48:36.318'!
animations

	^ self
		valueOfProperty: #animations
		ifAbsent: [self
			setProperty: #animations
			toValue: OrderedCollection new.
			self animations]! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 5/17/2010 14:34:02.46'!
darken

	self darkenAnimation
		direction: #forward;
		start.! !

!Morph methodsFor: '*animations-support' stamp: 'mt 6/7/2010 15:24:50.774'!
darkenAnimation

	^ self animations
		detect: [:anim | anim isGraphicsAnimation and: [anim type = #brightness]]
		ifNone: [
			(AnimBrightnessAnimation
				darkenOn: self
				to: 0.2
				duration: 200)
				register]! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 5/17/2010 15:03:35.323'!
fadeIn

	self fadeInThen: [].! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 6/7/2010 15:24:37.806'!
fadeInThen: aBlock

	self show.
	(AnimAlphaBlendAnimation
		fadeInOn: self
		duration: 200)
		finishBlock: [aBlock value];
		register;
		start: #deleteWhenFinished.! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 5/17/2010 14:56:48.698'!
fadeOut

	self fadeOutThen: [].! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 6/7/2010 15:24:37.768'!
fadeOutThen: aBlock

	(AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 200)
		finishBlock: [self hide. aBlock value];
		register;
		start: #deleteWhenFinished.! !

!Morph methodsFor: '*animations-core-override' stamp: 'mt 5/4/2011 15:25:25.594'!
fullDrawOn: aCanvas
	"Draw the full Morphic structure on the given Canvas.
	
	OVERRIDE: Was in 'drawing' category. Simulate Animation Framework."

	AnimAnimationRegistry morphicDrawBlock
		value: self value: aCanvas.! !

!Morph methodsFor: '*animations-core' stamp: 'mt 5/4/2011 15:24:11.816'!
fullDrawOnReally: aCanvas
	"Draw the full Morphic structure on the given Canvas."
	
	| transformedCanvas |  
	self visible ifFalse: [^ self].
	(aCanvas isVisible: self fullBounds) ifFalse:[^ self].
	(self hasProperty: #errorOnDraw)
		ifTrue:[^ self drawErrorOn: aCanvas].

	transformedCanvas := self transformedCanvasOn: aCanvas.

	"Note: At some point we should generalize this into some sort of 
	multi-canvas so that we can cross-optimize some drawing operations."
	"Pass 1: Draw eventual drop-shadow"
	self hasDropShadow
		ifTrue: [self drawDropShadowOn: transformedCanvas].
	(self hasRolloverBorder
		and: [(transformedCanvas seesNothingOutside: self bounds) not])
		ifTrue: [self drawRolloverBorderOn: transformedCanvas].

	"Pass 2: Draw receiver itself"
	transformedCanvas roundCornersOf: self during:[
		(transformedCanvas isVisible: self bounds) 					ifTrue:[transformedCanvas drawMorph: self].
		self
			drawSubmorphsOn: transformedCanvas;
			drawDropHighlightOn: transformedCanvas;
			drawMouseDownHighlightOn: transformedCanvas].! !

!Morph methodsFor: '*animations-core' stamp: 'mt 5/17/2010 16:42:06.037'!
ignoresColorMappings

	^ self
		valueOfProperty: #ignoresColorMappings
		ifAbsent: false.! !

!Morph methodsFor: '*animations-core' stamp: 'mt 5/17/2010 16:34:56.54'!
ignoresColorMappings: aBoolean

	self
		setProperty: #ignoresColorMappings
		toValue: aBoolean.! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 5/17/2010 14:40:42.927'!
lighten

	self darkenAnimation
		direction: #backward;
		start.! !

!Morph methodsFor: '*animations-core' stamp: 'mt 6/16/2010 12:00:04.032'!
redraw
	"Redraw this morph immediately. Calling this method from within #fullDraw or #draw may lead to infinite recursion."

	self redrawLater.
		
	World displayWorldSafely.! !

!Morph methodsFor: '*animations-core' stamp: 'mt 6/16/2010 11:59:55.64'!
redrawLater

	fullBounds 
		ifNil:[self invalidRect: self outerBounds]
		ifNotNil:[self invalidRect: fullBounds].! !

!Morph methodsFor: '*animations-core' stamp: 'mt 5/4/2011 15:02:52.682'!
transformedCanvasOn: aCanvas

	| transformedCanvas |
	transformedCanvas := self ignoresColorMappings
		ifTrue: [aCanvas originalCanvas]
		ifFalse: [AnimAnimationRegistry main transformedCanvasFor: self from: aCanvas].
		
	(AnimAnimationRegistry main isAtLeastOneGraphicsAnimationRunningFor: self)
		ifTrue: [self invalidRect: (transformedCanvas clipRect intersect: self fullBounds)].
		
	^ transformedCanvas! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 6/7/2010 15:25:32.226'!
walkToPosition: aPoint

	(AnimPropertyAnimation
		on: self
		property: #position
		start: self position
		end: aPoint
		duration: 200)
		register;
		start: #deleteWhenFinished.! !

!Morph methodsFor: '*animations-examples' stamp: 'mt 5/18/2010 17:52:00.59'!
warpToPosition: aPoint

	self fadeOutThen: [
		self
			position: aPoint;
			fadeIn].! !

!WorldState methodsFor: '*animations-core-override' stamp: 'mt 6/30/2011 10:00:42.855'!
doOneCycleFor: aWorld
	"Do one cycle of the interaction loop. This method is called repeatedly when the world is running.

This is a moderately private method; a better alternative is usually either to wait for events or to check the state of things from #step methods.

	OVERRIDE: Was in 'update cycle' category."

	self interCyclePause: (Preferences higherPerformance ifTrue: [1] ifFalse: [16"MinCycleLapse"]).
	self doOneCycleNowFor: aWorld.
	
	"Simulate Animation Framework"
	AnimAnimation updateReferenceTime.
	AnimAnimationRegistry main
		"displayFPS;"
		updateAnimations.! !

ColorMappingCanvas subclass: #AnimColorMappingCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Canvas'!

!AnimColorMappingCanvas commentStamp: 'mt 5/17/2010 08:42:09.163' prior: 0!
This is an extended version of the ColorMappingCanvas that supports more functionality of a FormCanvas.!

AnimColorMappingCanvas subclass: #AnimAlphaBlendingCanvas
	instanceVariableNames: 'alpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Canvas'!

!AnimAlphaBlendingCanvas class methodsFor: 'defaults' stamp: 'mt 5/17/2010 11:44:12.838'!
defaultRule

	^ Form blendAlpha! !

!AnimAlphaBlendingCanvas methodsFor: 'accessing' stamp: 'mt 5/17/2010 08:43:12.954'!
alpha

	^ alpha ifNil: [alpha := 1.0]! !

!AnimAlphaBlendingCanvas methodsFor: 'accessing' stamp: 'mt 5/17/2010 08:43:21.706'!
alpha: aFloat

	alpha := aFloat.! !

!AnimAlphaBlendingCanvas methodsFor: 'private' stamp: 'mt 6/22/2010 15:36:30.494'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule

	| convertedForm applyStaticAlpha |
	convertedForm := self convertForm: aForm.
	applyStaticAlpha := convertedForm == aForm.

	applyStaticAlpha ifFalse: [
		^ myCanvas
			image: convertedForm
			at: aPoint
			sourceRect: sourceRect
			rule: rule
		].

	rule = Form blend ifTrue: [
		^ myCanvas
			image: convertedForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha
		].
	
	rule = Form paint ifTrue:[
		^myCanvas
			image: convertedForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form paintAlpha
			alpha: alpha.
	].

	rule = Form over ifTrue:[
		^myCanvas
			image: convertedForm
			at: aPoint
			sourceRect: sourceRect
			rule: Form blendAlpha
			alpha: alpha.
	].! !

!AnimAlphaBlendingCanvas methodsFor: 'private' stamp: 'mt 5/17/2010 08:44:00.672'!
mapColor: aColor

	aColor isTransparent
		ifTrue:[^aColor].
		
	aColor isOpaque
		ifTrue:[^aColor alpha: alpha].
		
	^ aColor alpha: (aColor alpha * alpha)! !

!AnimAlphaBlendingCanvas methodsFor: 'private' stamp: 'mt 4/8/2011 12:32:09.896'!
mapFillStyle: aFillStyle

	self alpha = 1.0
		ifTrue: [^ aFillStyle].
	
	^ super mapFillStyle: aFillStyle ! !

AnimColorMappingCanvas subclass: #AnimBrightnessMappingCanvas
	instanceVariableNames: 'brightness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Canvas'!

!AnimBrightnessMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/14/2010 18:31:07.653'!
brightness

	^ brightness ifNil: [brightness := 1.0]! !

!AnimBrightnessMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/14/2010 18:31:23.54'!
brightness: aFloat

	brightness := aFloat.! !

!AnimBrightnessMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/17/2010 16:20:07.651'!
mapColor: aColor

	^ Color
		h: aColor hue
		s: aColor saturation
		v: (aColor brightness * self brightness min: 1.0 max: 0.0)
		alpha: aColor alpha! !

!AnimColorMappingCanvas class methodsFor: 'defaults' stamp: 'mt 5/17/2010 11:13:08.779'!
defaultRule

	^ Form paint! !

!AnimColorMappingCanvas methodsFor: 'converting' stamp: 'mt 4/17/2011 16:25:59.037'!
convertForm: aForm
	"Pixel-wise color mapping for very small forms. Performance reasons."
	
	aForm extent <= (64@64)
		ifTrue: [^ aForm collectColors: [:color | self mapColor: color]].
		
	^ aForm! !

!AnimColorMappingCanvas methodsFor: 'drawing-polygons' stamp: 'mt 5/17/2010 16:06:11.153'!
drawPolygon: vertices color: aColor borderWidth: bw borderColor: bc

	^ myCanvas
		drawPolygon: vertices
		color: (self mapColor: aColor)
		borderWidth: bw
		borderColor: (self mapColor: bc)! !

!AnimColorMappingCanvas methodsFor: 'drawing-polygons' stamp: 'mt 5/17/2010 16:04:29.867'!
drawPolygon: vertices fillStyle: aFillStyle borderWidth: bw borderColor: bc

	^ myCanvas
		drawPolygon: vertices
		fillStyle: (self mapFillStyle: aFillStyle)
		borderWidth: bw
		borderColor: (self mapColor: bc)! !

!AnimColorMappingCanvas methodsFor: 'drawing-rectangles' stamp: 'mt 4/8/2011 12:30:19.27'!
fillRoundRect: aRectangle radius: radius fillStyle: aFillStyle

	^ myCanvas
		fillRoundRect: aRectangle
		radius: radius
		fillStyle: (self mapFillStyle: aFillStyle)! !

!AnimColorMappingCanvas methodsFor: 'drawing-rectangles' stamp: 'mt 5/17/2010 08:48:29.968'!
frameAndFillRoundRect: aRectangle radius: cornerRadius fillStyle: fillStyle borderWidth: bw borderColor: bc

	^ myCanvas
		frameAndFillRoundRect: aRectangle
		radius: cornerRadius
		fillStyle: (self mapFillStyle: fillStyle)
		borderWidth: bw
		borderColor: (self mapColor: bc)! !

!AnimColorMappingCanvas methodsFor: 'drawing-rectangles' stamp: 'mt 6/16/2010 18:11:22.96'!
frameRoundRect: aRectangle radius: radius width: borderWidth color: borderColor

	^ myCanvas
		frameRoundRect: aRectangle
		radius: radius
		width: borderWidth
		color: (self mapColor: borderColor)! !

!AnimColorMappingCanvas methodsFor: 'private' stamp: 'mt 6/22/2010 15:37:45.46'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule

	^ myCanvas
		image: (self convertForm: aForm)
		at: aPoint
		sourceRect: sourceRect
		rule: rule.! !

!AnimColorMappingCanvas methodsFor: 'private' stamp: 'mt 5/17/2010 08:51:56.569'!
mapFillStyle: aFillStyle

	^ self mapColor: aFillStyle asColor! !

!AnimColorMappingCanvas methodsFor: 'accessing - private' stamp: 'mt 5/17/2010 16:27:35.517'!
myCanvas

	^ myCanvas! !

!AnimColorMappingCanvas methodsFor: 'accessing' stamp: 'mt 6/7/2010 15:26:00.446'!
originalCanvas
	"Return the original canvas without color mappings."
	
	| originalCanvas |
	originalCanvas := myCanvas.
	[originalCanvas isKindOf: AnimColorMappingCanvas]
		whileTrue: [originalCanvas := originalCanvas myCanvas].
	^ originalCanvas! !

!AnimColorMappingCanvas methodsFor: 'drawing' stamp: 'mt 11/16/2010 20:13'!
paragraph: paragraph bounds: bounds color: c

	| textColors oldColors |
	textColors := OrderedCollection new.
	paragraph text runs values do: [:array |
		array do: [:attr | (attr isKindOf: TextColor)
			ifTrue: [textColors addIfNotPresent: attr]]].

	oldColors := textColors collect: [:tc | tc color].
	textColors do: [:tc | tc color: (self mapColor: tc color)].

	super paragraph: paragraph bounds: bounds color: c.

	textColors withIndexDo: [:tc :i| tc color: (oldColors at: i)].! !

AnimColorMappingCanvas subclass: #AnimGrayscaleMappingCanvas
	instanceVariableNames: 'ratio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Canvas'!

!AnimGrayscaleMappingCanvas methodsFor: 'private' stamp: 'mt 5/15/2010 18:33:38.8'!
mapColor: aColor

	| avg |
	avg := { aColor red. aColor green. aColor blue } average.
	^ Color
		r: aColor red + ((avg - aColor red) * self ratio)
		g: aColor green + ((avg - aColor green) * self ratio)
		b: aColor blue + ((avg - aColor blue) * self ratio)
		alpha: aColor alpha! !

!AnimGrayscaleMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/15/2010 14:09:57.057'!
ratio

	^ ratio ifNil: [ratio := 1.0]! !

!AnimGrayscaleMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/15/2010 14:10:34.456'!
ratio: aFloat
	"Set the ratio between 0.0 for no change and 1.0 for grayscale."
	
	ratio := aFloat.! !

AnimColorMappingCanvas subclass: #AnimSaturationMappingCanvas
	instanceVariableNames: 'saturation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Canvas'!

!AnimSaturationMappingCanvas methodsFor: 'private' stamp: 'mt 5/15/2010 12:33:37.419'!
mapColor: aColor

	^ Color
		h: aColor hue
		s: (aColor saturation * self saturation min: 1.0 max: 0.0)
		v: aColor brightness
		alpha: aColor alpha! !

!AnimSaturationMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/14/2010 18:34:59.635'!
saturation

	^ saturation ifNil: [saturation := 1.0]! !

!AnimSaturationMappingCanvas methodsFor: 'accessing' stamp: 'mt 5/14/2010 18:35:10.374'!
saturation: aFloat

	saturation := aFloat.! !

TestCase subclass: #AnimTimedAnimationTest
	instanceVariableNames: 'referenceTime sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

AnimTimedAnimationTest subclass: #AnimAnimationRegistryTest
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimAnimationRegistryTest methodsFor: 'running' stamp: 'mt 6/16/2010 12:06:26.976'!
setUp

	super setUp.
	morph := Morph new.
	sut := AnimGraphicsAnimation new
		morph: morph;
		duration: 5000.! !

!AnimAnimationRegistryTest methodsFor: 'tests' stamp: 'mt 6/16/2010 12:10:25.069'!
testMorphDeletion

	AnimAnimationRegistry reset.

	self assert: AnimAnimationRegistry main graphicsAnimations isEmpty.

	sut := AnimGraphicsAnimation new
		morph: Morph new;
		duration: 5000;
		register.

	self assert: 1 equals: AnimAnimationRegistry main graphicsAnimations size.
	
	Smalltalk garbageCollect.
	AnimAnimationRegistry main garbageCollect.
	
	self assert: AnimAnimationRegistry main graphicsAnimations isEmpty.! !

AnimTimedAnimationTest subclass: #AnimAnimationTest
	instanceVariableNames: 'spy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimAnimationTest methodsFor: 'running' stamp: 'mt 6/7/2010 15:23:41.44'!
setUp

	super setUp.
	sut := AnimAnimation new
		duration: 10.
	spy := AnimSignalSpy on: sut.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:50:16.816'!
testAnimationEndState
		
	sut
		duration: 50;
		loopCount: 2;
		start.
		
	self wait: 100.
	
	self
		should: sut isStopped;
		should: sut currentLoop = 2;
		should: sut currentLoopTime = 49;
		should: sut currentTime = 99.
	
	sut
		resetAfterFinished: true;
		start.
		
	self wait: 100.
	
	self
		should: sut isStopped;
		should: sut currentLoop = 1;
		should: sut currentLoopTime = 0;
		should: sut currentTime = 0.
! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:53:04.34'!
testAnimationStates
		
	self should: sut isStopped.
		
	sut
		duration: 50;
		start.
	
	self
		should: sut isRunning;
		wait: 25;
		should: sut isRunning.
		
	sut pause.
	
	self should: sut isPaused.
	
	sut resume.
	
	self
		should: sut isRunning;
		wait: 25;
		should: sut isStopped.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:58:56.127'!
testInfiniteAnimation
	"This tests also possible time jumps."
	
	sut
		duration: 50;
		loopCount: -1;
		start.
		
	self wait: 500..
	
	self
		should: sut isRunning;
		should: sut currentLoop = 11;
		should: sut currentLoopTime = 0;
		should: sut currentTime = 500.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/14/2010 11:25:15.675'!
testOtherSignals

	sut
		duration: 50;
		loopCount: 2;
		direction: #backward.
	
	self
		should: spy lastSignal = #directionChanged;
		should: spy lastArguments = {#backward}.
		
	sut start.

	self
		wait: 51;
		should: spy lastSignal = #currentLoopChanged;
		should: spy lastArguments = 2;
		wait: 50;
		should: spy lastSignal = #finished.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:56:24.945'!
testPause
			
	sut
		duration: 50;
		start.
	
	self wait: 25.
	
	sut pause.
	
	self
		should: sut isPaused;
		should: sut currentTime = 25;
		wait: 25;
		should: sut isPaused;
		should: sut currentTime = 25.
		
	sut resume.
	
	self
		should: sut isRunning;
		should: sut currentTime = 25;
		wait: 25;
		should: sut isStopped;
		should: sut currentTime = 49.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/14/2010 11:19:06.573'!
testSignals

	sut
		duration: 50;
		start.
	
	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#stopped. #running}.
		
	sut pause.

	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#running. #paused}.
		
	sut stop.

	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#paused. #stopped}.
		
	sut
		start;
		stop.
	
	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#running. #stopped}.
! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:45:59.651'!
testSimpleAnimation

	self
		should: sut isStopped;
		should: sut currentLoop = 1;
		should: sut currentLoopTime = 0;
		should: sut currentTime = 0;
		should: sut loopCount = 1.
		
	sut
		duration: 50;
		start.
		
	self wait: 25.
	
	self
		should: sut isRunning;
		should: sut currentLoop = 1;
		should: sut currentLoopTime = 25;
		should: sut currentTime = 25.
		
	self wait: 25.
	
	self
		should: sut isStopped;
		should: sut currentLoop = 1;
		should: sut currentLoopTime = 49;
		should: sut currentTime = 49.
	
! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 12:00:51.331'!
testStartAnimation
	
	sut
		duration: 50;
		start.
	
	self wait: 25.
	
	sut start.
	
	self should: sut currentTime = 25.
	
	sut
		stop;
		start.
		
	self should: sut currentTime = 0.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/14/2010 11:19:20.924'!
testStateSignals

	sut
		duration: 50;
		start.
	
	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#stopped. #running}.
		
	sut pause.

	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#running. #paused}.
		
	sut stop.

	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#paused. #stopped}.
		
	sut
		start;
		stop.
	
	self
		should: spy lastSignal = #stateChanged;
		should: spy lastArguments = {#running. #stopped}.
! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/14/2010 11:13:35.239'!
testStopAnimation
	
	sut
		duration: 50;
		start.
	
	self 
		wait: 25;
		should: sut currentTime = 25.
	
	sut stop.
		
	self should: sut currentTime = 0.! !

!AnimAnimationTest methodsFor: 'tests' stamp: 'mt 5/12/2010 11:51:01.127'!
testTotalDuration
	
	sut
		duration: 50;
		loopCount: 2.
		
	self should: sut totalDuration = 100.! !

AnimTimedAnimationTest subclass: #AnimGraphicsAnimationTest
	instanceVariableNames: 'canvas morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimGraphicsAnimationTest methodsFor: 'running' stamp: 'mt 5/15/2010 12:00:51.951'!
setUp

	super setUp.
	morph := Morph new.
	canvas := FormCanvas extent: morph extent.! !

!AnimGraphicsAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:24:37.611'!
testAlphaBlendFadeIn

	sut := AnimAlphaBlendAnimation fadeInOn: morph duration: 50.
	sut start.
	
	self
		wait: 0;
		should: (sut transformedCanvas: canvas) alpha = 0.0;
		wait: 25;
		should: ((sut transformedCanvas: canvas) alpha roundTo: 0.1) = 0.5;
		wait: 25;
		should: ((sut transformedCanvas: canvas) alpha roundTo: 0.1) = 1.0.! !

!AnimGraphicsAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:24:37.661'!
testAlphaBlendFadeOut

	sut := AnimAlphaBlendAnimation fadeOutOn: morph duration: 50.
	sut start.
	
	self
		wait: 0;
		should: (sut transformedCanvas: canvas) alpha = 1.0;
		wait: 25;
		should: ((sut transformedCanvas: canvas) alpha roundTo: 0.1) = 0.5;
		wait: 25;
		should: ((sut transformedCanvas: canvas) alpha roundTo: 0.1) = 0.0.! !

!AnimGraphicsAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:24:50.649'!
testBrightnessColorMapping

	| color |
	color := Color blue.
	sut := AnimBrightnessAnimation darkenOn: morph to: 0.5 duration: 50.
	sut start.
	
	self
		should: color brightness = 1.0;
		wait: 0;
		should: ((sut transformedCanvas: canvas) mapColor: color) brightness = 1.0;
		wait: 25;
		should: (((sut transformedCanvas: canvas) mapColor: color) brightness roundTo: 0.01) = 0.74;
		wait: 25;
		should: (((sut transformedCanvas: canvas) mapColor: color) brightness roundTo: 0.1) = 0.5.! !

!AnimGraphicsAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:24:50.723'!
testDarken

	sut := AnimBrightnessAnimation darkenOn: morph to: 0.5 duration: 50.
	sut start.
	
	self
		wait: 0;
		should: (sut transformedCanvas: canvas) brightness = 1.0;
		wait: 25;
		should: ((sut transformedCanvas: canvas) brightness roundTo: 0.01) = 0.74;
		wait: 25;
		should: ((sut transformedCanvas: canvas) brightness roundTo: 0.1) = 0.5.! !

!AnimGraphicsAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:25:12.383'!
testGrayscale

	| color mappedColor|
	color := Color r: 0.4 g: 0.6 b: 0.5 alpha: 1.0.
	sut := AnimGrayscaleAnimation grayOutOn: morph duration: 50.
	sut start.
	
	self wait: 50.
	
	mappedColor := (sut transformedCanvas: canvas) mapColor: color.
	
	self
		should: (mappedColor red roundTo: 0.1) = 0.5;
		should: (mappedColor green roundTo: 0.1) = 0.5;
		should: (mappedColor blue roundTo: 0.1) = 0.5.! !

AnimTimedAnimationTest subclass: #AnimPropertyAnimationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/24/2010 19:51:15.192'!
testFloats

	| valueHolder |
	valueHolder := ValueHolder new contents: 0.0.
	sut := (AnimPropertyAnimation
		on: valueHolder
		property: #contents
		start: 0.0
		end: 0.3234234234
		duration: 200)
		start.
	
	300 timesRepeat: [self wait: 1].
	
	self should: valueHolder contents = 0.3234234234.! !

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/24/2010 19:52:22.301'!
testFloatsReversed

	| valueHolder |
	valueHolder := ValueHolder new contents: 0.0.
	sut := (AnimPropertyAnimation
		on: valueHolder
		property: #contents
		start: 0.3234234234
		end: 0.0
		duration: 200)
		start.
	
	300 timesRepeat: [self wait: 1].
	
	self should: valueHolder contents = 0.0.! !

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/24/2010 19:59:42.459'!
testFloatsReversed2

	| valueHolder |
	valueHolder := ValueHolder new contents: 0.0.
	sut := (AnimPropertyAnimation
		on: valueHolder
		property: #contents
		start: 0.3
		end: 0.0
		duration: 200)
		start.
	
	self wait: 500.
	
	self should: valueHolder contents = 0.0.! !

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/7/2010 15:25:32.09'!
testMorphPositionChange

	| morph |
	morph := Morph new.
	sut := (AnimPropertyAnimation
		on: morph
		property: #position
		start: 0@0
		end: 6@12
		duration: 50)
		start.
		
	self
		wait: 25;
		should: morph position = (3@6);
		wait: 25;
		should: morph position = (6@12).! !

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/7/2010 15:25:32.057'!
testMorphPositionChangeWithOffset

	| morph |
	morph := Morph new.
	sut := (AnimPropertyAnimation
		on: morph
		property: #position
		start: 0@0
		end: 6@12
		duration: 50)
		offset: 10@10;
		start.
		
	self
		wait: 25;
		should: morph position = (13@16);
		wait: 25;
		should: morph position = (16@22).! !

!AnimPropertyAnimationTest methodsFor: 'tests' stamp: 'mt 6/7/2010 15:25:32.139'!
testMorphPositionChangeWithOffsetBlock

	| morph |
	morph := Morph new.
	sut := (AnimPropertyAnimation
		on: morph
		property: #position
		start: 0@0
		end: 6@12
		duration: 50)
		offsetBlock: [10@10];
		start.
		
	self
		wait: 25;
		should: morph position = (13@16);
		wait: 25;
		should: morph position = (16@22).! !

!AnimPropertyAnimationTest methodsFor: 'support' stamp: 'mt 5/14/2010 15:09:22.249'!
wait: milliseconds

	super wait: milliseconds.
	sut updateCurrentValue.! !

!AnimTimedAnimationTest methodsFor: 'running' stamp: 'mt 5/14/2010 12:48:23.036'!
setUp

	super setUp.
	referenceTime := WorldState lastCycleTime.! !

!AnimTimedAnimationTest methodsFor: 'support' stamp: 'mt 5/14/2010 12:48:59.212'!
wait: milliseconds
	"Wait some time in terms of the main world cycle."
	
	sut updateCurrentTime: referenceTime.

	referenceTime := referenceTime + milliseconds.
	
	sut updateCurrentTime: referenceTime.! !

AnimTimedAnimationTest subclass: #AnimVariantAnimationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimVariantAnimationTest methodsFor: 'running' stamp: 'mt 6/7/2010 15:23:51.684'!
setUp

	super setUp.
	sut := AnimVariantAnimation new.! !

!AnimVariantAnimationTest methodsFor: 'testing' stamp: 'mt 6/7/2010 15:27:00.622'!
testLinearInterpolation

	sut
		easingCurve: AnimEasingCurve linear;
		duration: 50;
		startValue: 1;
		endValue: 50;
		start.
		
	self
		should: sut currentValue rounded = 1;
		wait: 25;
		should: sut currentValue rounded = 26;
		wait: 60;
		should: sut isStopped;
		should: sut currentValue rounded = 50.! !

Object subclass: #AnimAnimation
	instanceVariableNames: 'deletionPolicy direction state currentLoop currentTime duration loopCount startTime pauseDuration resetAfterFinished finishedOnce finishBlock'
	classVariableNames: 'ReferenceTime'
	poolDictionaries: ''
	category: 'Animations-Core'!

!AnimAnimation commentStamp: 'mt 6/30/2011 09:59:07.207' prior: 0!
I am the abstract base class for all kinds of animations. If you use me with the world's #lastCycleTime all time, durations a.s.o. should be considered in milliseconds.

I emit the following changed-signals:

#finished ... The animation is done, e.g., after all loops are played.
#stateChanged ... Whenever the state of this animation changes. See #state:. The arguments containt the old and the new one.
#currentLoopChanged ... Whenever #currentLoop changes. Contains the current loop number.
#directionChanged ... Whenever #direction changes. Contains the new direction.

Animations use a custom ReferenceTime as "WorldState lastCycleTime" does not work for busy cycles.

Note: This is some kind of a Squeak port of the Nokia Qt 4.6 Animation Framework.!

!AnimAnimation class methodsFor: 'time' stamp: 'mt 6/30/2011 09:57:44.885'!
updateReferenceTime

	ReferenceTime := Time millisecondClockValue.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:32:58.926'!
currentLoop

	^ currentLoop ifNil: [currentLoop := 1]! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 11:00:46.441'!
currentLoop: anInteger

	currentLoop ~= anInteger ifTrue: [
		currentLoop := anInteger.
		self changed: #currentLoopChanged with: currentLoop].! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:47:03.583'!
currentLoopTime
	"Return the current time inside the current loop. Starts at 0 and ends at #duration."
	
	^ self currentTime \\ self duration! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:32:39.8'!
currentTime
	"The current time starts at 0 and ends at #totalDuration."

	^ currentTime ifNil: [currentTime := 0]! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 09:12:27.466'!
currentTime: anInteger

	currentTime := anInteger.! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 20:25:08.059'!
deletionPolicy

	^ deletionPolicy ifNil: [deletionPolicy := #deleteWhenFinished]! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 20:06:36.475'!
deletionPolicy: aPolicy
	"#keepWhenFinished, #deleteWhenFinished"
	
	deletionPolicy := aPolicy.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:32:27.874'!
direction

	^ direction ifNil: [direction := #forward]! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:23:30.9'!
direction: aDirection
	"#forward, #backward"
	
	aDirection ~=  direction ifTrue: [
		direction := aDirection.
		self changed: #directionChanged with: {aDirection}].! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 11:10:27.148'!
duration

	^ duration ifNil: [Error signal: 'Animation duration was not set!!']! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 09:17:29.683'!
duration: anInteger

	duration := anInteger.! !

!AnimAnimation methodsFor: 'control - private' stamp: 'mt 5/17/2010 14:13:55.713'!
finish

	self stop.
	
	self resetAfterFinished
		ifTrue: [self toStart]
		ifFalse: [self toEnd].
		
	self
		finishedOnce: true;
		changed: #finished.
		
	self finishBlock value.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:14:05.399'!
finishBlock
	
	^ finishBlock ifNil: [[]]! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:13:38.918'!
finishBlock: aBlock
	"This block will be evaluated on finish."
	
	finishBlock := aBlock.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 20:17:01.832'!
finishedOnce
	"This flag is primarily used by the animation registry to perform garbage collection."

	^ finishedOnce ifNil: [finishedOnce := false]! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 20:16:04.971'!
finishedOnce: aBoolean

	finishedOnce := aBoolean.! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/14/2010 19:31:37.335'!
isGraphicsAnimation

	^ false! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/12/2010 10:10:10.919'!
isInfinite

	^ self loopCount = -1! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/12/2010 09:53:32.112'!
isPaused

	^ self state = #paused! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/14/2010 19:31:43.761'!
isPropertyAnimation

	^ false! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/12/2010 09:53:29.451'!
isRunning

	^ self state = #running! !

!AnimAnimation methodsFor: 'testing' stamp: 'mt 5/12/2010 09:53:26.603'!
isStopped

	^ self state = #stopped! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 09:36:21.713'!
loopCount

	^ loopCount ifNil: [loopCount := 1]! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 09:42:34.762'!
loopCount: anInteger
	"Define how often the animation will be played.
	
	0 ... not played at all
	n ... run animation n times (default: 1)
	-1 ... run animation forever"

	loopCount := anInteger.! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/12/2010 10:35:33.769'!
pause
	"This will pause the animation. #currentTime remains unchanged until #start or #resume is called."
	
	self isRunning ifTrue: [
		self state: #paused].! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 10:21:00.008'!
pauseDuration

	^ pauseDuration ifNil: [pauseDuration := 0]! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 10:21:32.48'!
pauseDuration: anInteger
	"Define that part of the time that should be ignored."

	pauseDuration := anInteger.! !

!AnimAnimation methodsFor: 'registering' stamp: 'mt 6/7/2010 15:25:44.801'!
register

	AnimAnimationRegistry main register: self.! !

!AnimAnimation methodsFor: 'control - private' stamp: 'mt 5/15/2010 18:23:43.585'!
reset

	self
		toStart;
		finishedOnce: false;
		startTime: nil.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:50:47.79'!
resetAfterFinished

	^ resetAfterFinished ifNil: [resetAfterFinished := false]! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:51:47.207'!
resetAfterFinished: aBoolean
	"Set the animation to the beginning after it has ended. Is not used for infinite loops."

	resetAfterFinished := aBoolean.! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/12/2010 10:35:49.11'!
resume
	"Resumes a paused animation."
	
	self isPaused ifTrue: [
		self state: #running].! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/17/2010 07:45:52.436'!
reverse

	self direction = #forward
		ifTrue: [self direction: #backward]
		ifFalse: [self direction: #forward].! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/15/2010 18:00:37.484'!
start
	
	self start: #keepWhenFinished.! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/15/2010 18:00:22.499'!
start: aDeletionPolicy
	"If the animation is paused or stopped the animation will be rewinded and start from the beginning. If the animation is running, nothing will happen."
	
	self isRunning ifFalse: [
		self
			deletionPolicy: aDeletionPolicy;
			reset;
			state: #running].! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 09:55:04.048'!
startTime

	^ startTime! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 09:54:55.696'!
startTime: anInteger
	"Used to calculate everything."

	startTime := anInteger.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 10:31:26.03'!
state

	^ state ifNil: [state := #stopped]! !

!AnimAnimation methodsFor: 'accessing - private' stamp: 'mt 5/12/2010 10:02:57.196'!
state: aState
	"#stopped, #paused, #running"
	
	aState ~= state ifTrue: [
		| oldState |
		oldState := state.
		state := aState.
		self changed: #stateChanged with: {oldState. aState}].! !

!AnimAnimation methodsFor: 'control' stamp: 'mt 5/12/2010 12:03:11.694'!
stop

	self
		state: #stopped;
		toStart.! !

!AnimAnimation methodsFor: 'control - private' stamp: 'mt 5/15/2010 18:23:31.947'!
toEnd

	self
		currentLoop: (self loopCount max: 1);
		currentTime: (self duration * self loopCount) - 1;
		pauseDuration: 0.! !

!AnimAnimation methodsFor: 'control - private' stamp: 'mt 5/15/2010 18:23:20.861'!
toStart

	self
		currentLoop: 1;
		currentTime: 0;
		pauseDuration: 0.! !

!AnimAnimation methodsFor: 'accessing' stamp: 'mt 5/12/2010 09:33:30.059'!
totalDuration

	^ self duration * self loopCount! !

!AnimAnimation methodsFor: 'registering' stamp: 'mt 6/7/2010 15:25:44.876'!
unregister

	AnimAnimationRegistry main unregister: self.! !

!AnimAnimation methodsFor: 'updating - private' stamp: 'mt 5/14/2010 11:30:33.798'!
updateCurrentLoop
	"Detect loop end and change."
	
	(self currentTime // self duration) >= self currentLoop
		ifTrue: [self currentLoop: (self currentTime // self duration) + 1].! !

!AnimAnimation methodsFor: 'updating' stamp: 'mt 6/30/2011 10:00:25.199'!
updateCurrentTime

	self updateCurrentTime: ReferenceTime.! !

!AnimAnimation methodsFor: 'updating' stamp: 'mt 5/12/2010 11:58:10.017'!
updateCurrentTime: referenceTime
	"This should be called frequently to keep the animation running."

	self isStopped ifTrue: [^ self].
	
	"Set an accurate start time in the first update cycle."
	self startTime ifNil: [
		self startTime: referenceTime].

	self isRunning ifTrue: [
		self
			currentTime: (referenceTime - self startTime) - self pauseDuration;
			updateCurrentLoop;
			updateState].
		
	self isPaused ifTrue: [
		self pauseDuration: (referenceTime - self startTime) - self currentTime].! !

!AnimAnimation methodsFor: 'updating - private' stamp: 'mt 5/12/2010 10:55:07.045'!
updateState

	self isInfinite
		ifTrue: [^ self].
	
	self currentLoop > self loopCount
		ifTrue: [self finish]! !

AnimAnimation subclass: #AnimVariantAnimation
	instanceVariableNames: 'easingCurve startValue endValue offset offsetBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Core'!

!AnimVariantAnimation commentStamp: 'mt 5/14/2010 14:43:20.077' prior: 0!
I extend the abstract animation with some value interpolation behaviour (besides the time). You can keep me running by calling #updateCurrentTime and #updateCurrentValue frequently.!

AnimVariantAnimation subclass: #AnimGraphicsAnimation
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Core'!

!AnimGraphicsAnimation commentStamp: 'mt 5/14/2010 16:44:02.071' prior: 0!
I am capable of graphic effects, e.g., fade-in or fade-out.!

AnimGraphicsAnimation subclass: #AnimAlphaBlendAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Animations'!

!AnimAlphaBlendAnimation class methodsFor: 'examples' stamp: 'mt 6/7/2010 15:24:37.486'!
example1

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	
	(AnimAlphaBlendAnimation fadeInOn: morph duration: 2000)
		register;
		start.
		
	morph openInWorld.! !

!AnimAlphaBlendAnimation class methodsFor: 'examples' stamp: 'mt 6/7/2010 15:24:37.578'!
example2

	| morph |
	morph := 'Hello, World!!' asText asMorph
		position: 50@50;
		extent: 100@100.
	
	(AnimAlphaBlendAnimation fadeOutOn: morph duration: 2000)
		register;
		start.
		
	morph openInWorld.! !

!AnimAlphaBlendAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 20:27:06.784'!
fadeInOn: aMorph duration: milliseconds

	^ self
		fadeInOn: aMorph
		to: 1.0
		duration: milliseconds! !

!AnimAlphaBlendAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 19:16:33.804'!
fadeInOn: aMorph to: aValue duration: milliseconds

	^ self new
		morph: aMorph;
		duration: milliseconds;
		startValue: 0.0;
		endValue: aValue! !

!AnimAlphaBlendAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 19:18:05.165'!
fadeOutOn: aMorph duration: milliseconds

	^ self
		fadeOutOn: aMorph
		to: 0.0
		duration: milliseconds! !

!AnimAlphaBlendAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 19:17:33.897'!
fadeOutOn: aMorph to: aValue duration: milliseconds

	^ self new
		morph: aMorph;
		duration: milliseconds;
		startValue: 1.0;
		endValue: aValue! !

!AnimAlphaBlendAnimation methodsFor: 'interpolating' stamp: 'mt 6/7/2010 15:26:10.967'!
transformedCanvas: aCanvas

	^ (AnimAlphaBlendingCanvas
		on: aCanvas)
		alpha: self currentValue! !

!AnimAlphaBlendAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:22:08.807'!
type

	^ #alpha! !

AnimGraphicsAnimation subclass: #AnimBrightnessAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Animations'!

!AnimBrightnessAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 20:47:16.133'!
darkenOn: aMorph to: aValue duration: milliseconds
	"Example: If you want to darken the color by 50% aValue should be 0.5."

	^ self new
		morph: aMorph;
		duration: milliseconds;
		startValue: 1.0;
		endValue: 1.0 - aValue! !

!AnimBrightnessAnimation class methodsFor: 'examples' stamp: 'mt 6/7/2010 15:24:50.544'!
example1

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	
	(AnimBrightnessAnimation darkenOn: morph to: 1.0 duration: 5000)
		register;
		start.
		
	morph openInWorld.! !

!AnimBrightnessAnimation class methodsFor: 'examples' stamp: 'mt 6/7/2010 15:24:50.588'!
example2

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	morph addMorph: (Morph new
		position: 60@60;
		extent: 80@80;
		color: Color yellow).
	
	(AnimBrightnessAnimation darkenOn: morph to: 1.0 duration: 5000)
		start;
		register.
		
	morph openInWorld.! !

!AnimBrightnessAnimation methodsFor: 'interpolating' stamp: 'mt 6/7/2010 15:26:21.98'!
transformedCanvas: aCanvas

	^ (AnimBrightnessMappingCanvas
		on: aCanvas)
		brightness: self currentValue! !

!AnimBrightnessAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:22:19.717'!
type

	^ #brightness! !

!AnimGraphicsAnimation methodsFor: 'testing' stamp: 'mt 5/14/2010 19:32:07.36'!
isGraphicsAnimation

	^ true! !

!AnimGraphicsAnimation methodsFor: 'accessing' stamp: 'mt 6/16/2010 11:54:53.963'!
morph

	morph ifNil: [morph := WeakArray new: 1].
		
	^ morph at: 1.! !

!AnimGraphicsAnimation methodsFor: 'accessing' stamp: 'mt 6/16/2010 12:04:40.875'!
morph: aMorph

	morph ifNil: [morph := WeakArray new: 1].
	morph at: 1 put: aMorph.! !

!AnimGraphicsAnimation methodsFor: 'updating - private' stamp: 'mt 6/16/2010 12:00:37.275'!
repaint

	self morph ifNil: [^ self].
	self morph redrawLater.! !

!AnimGraphicsAnimation methodsFor: 'control' stamp: 'mt 5/15/2010 18:16:21.399'!
resume

	super resume.
	self repaint.! !

!AnimGraphicsAnimation methodsFor: 'control' stamp: 'mt 5/15/2010 18:16:15.412'!
start

	super start.
	self repaint.! !

!AnimGraphicsAnimation methodsFor: 'control' stamp: 'mt 5/15/2010 18:18:31.869'!
stop

	super stop.
	self repaint.! !

!AnimGraphicsAnimation methodsFor: 'interpolating' stamp: 'mt 5/14/2010 18:51:16.154'!
transformedCanvas: aCanvas

	self subclassResponsibility.! !

!AnimGraphicsAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:21:57.388'!
type

	^ #graphics! !

!AnimGraphicsAnimation methodsFor: 'updating' stamp: 'mt 5/14/2010 16:49:13.97'!
updateCurrentValue: aValue
	"Do nothing here."
	! !

AnimGraphicsAnimation subclass: #AnimGrayscaleAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Animations'!

!AnimGrayscaleAnimation class methodsFor: 'examples' stamp: 'mt 6/7/2010 15:25:12.287'!
example1

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	morph addMorph: (Morph new
		position: 60@60;
		extent: 80@80;
		color: Color yellow).
	
	(AnimGrayscaleAnimation grayOutOn: morph duration: 5000)
		start;
		register.
		
	morph openInWorld.! !

!AnimGrayscaleAnimation class methodsFor: 'instance creation' stamp: 'mt 5/15/2010 14:12:30.361'!
grayOutOn: aMorph duration: milliseconds

	^ self new
		morph: aMorph;
		duration: milliseconds;
		startValue: 0.0;
		endValue: 1.0! !

!AnimGrayscaleAnimation methodsFor: 'interpolating' stamp: 'mt 6/7/2010 15:26:32.537'!
transformedCanvas: aCanvas

	^ (AnimGrayscaleMappingCanvas
		on: aCanvas)
		ratio: self currentValue! !

!AnimGrayscaleAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:22:32.926'!
type

	^ #grayscale! !

AnimGraphicsAnimation subclass: #AnimSaturationAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Animations'!

!AnimSaturationAnimation methodsFor: 'interpolating' stamp: 'mt 6/7/2010 15:26:44.824'!
transformedCanvas: aCanvas

	^ (AnimSaturationMappingCanvas
		on: aCanvas)
		saturation: self currentValue! !

!AnimSaturationAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 14:22:48.178'!
type

	^ #saturation! !

AnimVariantAnimation subclass: #AnimPropertyAnimation
	instanceVariableNames: 'target property'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Core'!

!AnimPropertyAnimation class methodsFor: 'examples' stamp: 'mt 6/16/2010 10:39:35.692'!
example1

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	morph addMorph: (Morph new
		position: 60@60;
		extent: 80@80;
		color: Color yellow).
	
	(AnimPropertyAnimation on: morph property: #position start: (50@50) end: (400@400) duration: 500)
		register;
		start: #deleteWhenFinished.
		
	morph openInWorld.! !

!AnimPropertyAnimation class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 16:34:42.775'!
on: anObject property: aProperty start: aStartValue end: anEndValue duration: milliseconds

	^ self new
		target: anObject;
		property: aProperty;
		startValue: aStartValue;
		endValue: anEndValue;
		duration: milliseconds! !

!AnimPropertyAnimation methodsFor: 'testing' stamp: 'mt 5/14/2010 19:31:56.258'!
isPropertyAnimation

	^ true! !

!AnimPropertyAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 14:48:24.768'!
property

	^ property! !

!AnimPropertyAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 16:34:33.236'!
property: aProperty

	property := aProperty.! !

!AnimPropertyAnimation methodsFor: 'accessing' stamp: 'mt 6/16/2010 11:55:40.521'!
target

	target ifNil: [target := WeakArray new: 1].
		
	^ target at: 1.! !

!AnimPropertyAnimation methodsFor: 'accessing' stamp: 'mt 6/16/2010 12:04:51.334'!
target: anObject

	target ifNil: [target := WeakArray new: 1].
	target at: 1 put: anObject.! !

!AnimPropertyAnimation methodsFor: 'updating' stamp: 'mt 6/16/2010 11:56:26.322'!
updateCurrentValue: aValue

	self target ifNil: [^ self].
	
	self target
		perform: (self property, #:) asSymbol
		with: aValue.! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:23:21.929'!
currentValue

	| v o |
	v := self
		interpolatedFrom: self startValue
		to: self endValue
		progress: self currentLoopTime asFloat / ((self duration - 1) max: 1).
	o := self offset.
	
	^ o
		ifNil: [v]
		ifNotNil: [v + o]! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 6/7/2010 15:27:00.533'!
easingCurve

	^ easingCurve ifNil: [easingCurve := AnimEasingCurve new]! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 12:42:22.17'!
easingCurve: anEasingCurve

	easingCurve := anEasingCurve.! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 12:29:23.688'!
endValue

	^ endValue! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 12:29:15.244'!
endValue: anObject

	endValue := anObject.! !

!AnimVariantAnimation methodsFor: 'interpolating' stamp: 'mt 5/14/2010 16:53:16.721'!
interpolatedFrom: fromValue to: toValue progress: aFloat
	"Assumes simple numbers at the moment. Maybe a more complex interpolator could make other types possible."

	^ fromValue + ((toValue - fromValue) *
		(self direction = #backward
			ifTrue: [1.0 - (self easingCurve valueForProgress: aFloat)]
			ifFalse: [self easingCurve valueForProgress: aFloat]))! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:21:52.712'!
offset
	
	^ self offsetBlock
		ifNotNil: [self offsetBlock value]
		ifNil: [offset]! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:20:18.206'!
offset: aValue

	offset := aValue.! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:20:55.789'!
offsetBlock
	
	^ offsetBlock! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:21:26.062'!
offsetBlock: aBlock
	"Will be used to calculate the offset dynamically. See #offset."
	
	offsetBlock := aBlock.! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 12:29:04.466'!
startValue

	^ startValue! !

!AnimVariantAnimation methodsFor: 'accessing' stamp: 'mt 5/14/2010 12:28:54.496'!
startValue: anObject

	startValue := anObject.! !

!AnimVariantAnimation methodsFor: 'updating' stamp: 'mt 5/14/2010 14:42:02.972'!
updateCurrentValue

	self updateCurrentValue: self currentValue.! !

!AnimVariantAnimation methodsFor: 'updating' stamp: 'mt 5/14/2010 12:40:20.228'!
updateCurrentValue: aValue

	self subclassResponsibility.! !

Object subclass: #AnimAnimationRegistry
	instanceVariableNames: 'propertyAnimations graphicsAnimations mutex lastGCTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Core'!

AnimAnimationRegistry class
	instanceVariableNames: 'instance morphicDrawBlock'!

!AnimAnimationRegistry commentStamp: 'mt 5/17/2010 15:48:31.878' prior: 0!
Should be thread-safe.!

AnimAnimationRegistry class
	instanceVariableNames: 'instance morphicDrawBlock'!

!AnimAnimationRegistry class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 19:36:29.412'!
main
	"Return the main registry for animations that is queried in each world cycle."
	
	^ instance ifNil: [instance := self new]! !

!AnimAnimationRegistry class methodsFor: 'accessing' stamp: 'mt 5/4/2011 15:24:55.956'!
morphicDrawBlock
	"Draw the full Morphic structure on the given Canvas."
	
	^ morphicDrawBlock ifNil: [morphicDrawBlock := [:morph :canvas |
			morph fullDrawOnReally: canvas.]].! !

!AnimAnimationRegistry class methodsFor: 'accessing' stamp: 'mt 5/4/2011 15:18:03.063'!
morphicDrawBlock: aBlock
	"Set a new piece of code that is called in #fullDrawOn: given a morph and a canvas."

	morphicDrawBlock := aBlock.! !

!AnimAnimationRegistry class methodsFor: 'instance creation' stamp: 'mt 6/16/2010 12:08:25.188'!
reset
	
	instance := nil.! !

!AnimAnimationRegistry methodsFor: 'queries' stamp: 'mt 5/17/2010 15:46:38.126'!
animationsFor: anObject

	self mutex critical: [
		^ (self graphicsAnimations select: [:anim | anim morph = anObject]),
			(self propertyAnimations select: [:anim | anim target = anObject])].
! !

!AnimAnimationRegistry methodsFor: 'registering' stamp: 'mt 4/22/2011 11:51:54.289'!
clear

	self mutex critical: [
		"Clear local animation caches."
		self graphicsAnimations do: [:anim |
			anim morph ifNotNil: [:m | m removeProperty: #animations]].
		
		propertyAnimations := nil.
		graphicsAnimations := nil].! !

!AnimAnimationRegistry methodsFor: 'queries' stamp: 'mt 5/3/2011 11:22:28.201'!
displayFPS

	(Smalltalk includesKey: #frameCountStartTime)
		ifFalse: [Smalltalk at: #frameCountStartTime put: WorldState lastCycleTime].
	(Smalltalk includesKey: #currentFrameCount)
		ifFalse: [Smalltalk at: #currentFrameCount put: 0].
	(Smalltalk includesKey: #lastFPS)
		ifFalse: [Smalltalk at: #lastFPS put: 0].

	(WorldState lastCycleTime - (Smalltalk at: #frameCountStartTime)) < 0
		ifTrue: [
			Smalltalk at: #frameCountStartTime put: WorldState lastCycleTime].

	(WorldState lastCycleTime - (Smalltalk at: #frameCountStartTime)) > 1000
		ifTrue: [
			Smalltalk
				at: #lastFPS put: (Smalltalk at: #currentFrameCount);
				at: #currentFrameCount put: 0;
				at: #frameCountStartTime put: WorldState lastCycleTime].
			
	Smalltalk at: #currentFrameCount put: (Smalltalk at: #currentFrameCount) + 1.
	(Smalltalk at: #lastFPS) asString, ' FPS' displayAt: 0@18.! !

!AnimAnimationRegistry methodsFor: 'updating - private' stamp: 'mt 6/16/2010 12:03:28.468'!
garbageCollect

	self propertyAnimations
		select: [:anim | anim target isNil or: [anim finishedOnce and: [anim deletionPolicy = #deleteWhenFinished]]]
		thenDo: [:anim | anim unregister].
		
	self graphicsAnimations
		select: [:anim | anim morph isNil or: [anim finishedOnce and: [anim deletionPolicy = #deleteWhenFinished]]]
		thenDo: [:anim | anim unregister].! !

!AnimAnimationRegistry methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 19:34:30.155'!
graphicsAnimations

	^ graphicsAnimations ifNil: [graphicsAnimations := OrderedCollection new]! !

!AnimAnimationRegistry methodsFor: 'queries' stamp: 'mt 4/22/2011 11:52:48.105'!
isAtLeastOneGraphicsAnimationRunningFor: aMorph
	"Use this query to schedule redraw operations."
	
	^ aMorph animations anySatisfy: [:anim | anim isRunning]! !

!AnimAnimationRegistry methodsFor: 'accessing - private' stamp: 'mt 5/17/2010 15:40:56.495'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!AnimAnimationRegistry methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 19:34:13.507'!
propertyAnimations

	^ propertyAnimations ifNil: [propertyAnimations := OrderedCollection new]! !

!AnimAnimationRegistry methodsFor: 'registering' stamp: 'mt 4/22/2011 11:49:15.402'!
register: anAnimation

	self mutex critical: [
		anAnimation isPropertyAnimation
			ifTrue: [self propertyAnimations add: anAnimation].
		
		anAnimation isGraphicsAnimation
			ifTrue: [
				self graphicsAnimations add: anAnimation.
				anAnimation morph ifNotNil: [:m |
					m animations add: anAnimation.
					m redrawLater]]].! !

!AnimAnimationRegistry methodsFor: 'queries' stamp: 'mt 4/22/2011 11:53:38.36'!
transformedCanvasFor: aMorph from: aCanvas

	| transformedCanvas |
	transformedCanvas := aCanvas.
	aMorph animations do: [:anim |
		transformedCanvas := anim transformedCanvas: transformedCanvas].
	^ transformedCanvas! !

!AnimAnimationRegistry methodsFor: 'updating - private' stamp: 'mt 3/29/2011 09:21:29.854'!
tryGarbageCollect

	| interval |
	interval := lastGCTime
		ifNil: [5000]
		ifNotNil: [:t | (t to: DateAndTime now) duration asMilliSeconds].
	
	interval < 0
		ifTrue: [interval := 5000].
	
	interval < 5000
		ifTrue: [^ self].
		
	self mutex critical: [self garbageCollect].
	
	lastGCTime := DateAndTime now.! !

!AnimAnimationRegistry methodsFor: 'registering' stamp: 'mt 4/22/2011 11:50:03.298'!
unregister: anAnimation

	self mutex critical: [
		anAnimation isPropertyAnimation
			ifTrue: [self propertyAnimations remove: anAnimation ifAbsent: []].
		
		anAnimation isGraphicsAnimation
			ifTrue: [
				self graphicsAnimations remove: anAnimation ifAbsent: [].
				anAnimation morph ifNotNil: [:m | m animations remove: anAnimation]]].! !

!AnimAnimationRegistry methodsFor: 'updating' stamp: 'mt 4/22/2011 11:55:10.654'!
updateAnimations

	self mutex critical: [[
		self
			updateCurrentTime;
			updateCurrentValues.
	] on: Error do: [:error | self clear. Error signal: 'There was an error in the animation framework. All animations were stopped']].

	self tryGarbageCollect.! !

!AnimAnimationRegistry methodsFor: 'updating - private' stamp: 'mt 5/14/2010 19:39:30.576'!
updateCurrentTime
	"Updates the reference time for each registered animation."
	
	self propertyAnimations do: [:anim | anim updateCurrentTime].
	self graphicsAnimations do: [:anim | anim updateCurrentTime].! !

!AnimAnimationRegistry methodsFor: 'updating - private' stamp: 'mt 5/3/2011 13:23:37.536'!
updateCurrentValues
	
	self propertyAnimations do: [:anim |
		anim updateCurrentValue.
		"GC here too. Needs mutex?"
		(anim target isNil or: [anim finishedOnce and: [anim deletionPolicy = #deleteWhenFinished]])
			ifTrue: [anim unregister]].! !

Object subclass: #AnimEasingCurve
	instanceVariableNames: 'type conversionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Core'!

!AnimEasingCurve commentStamp: 'mt 5/14/2010 19:28:46.069' prior: 0!
I am capable of defining the velocity for the interpolation of an XpfVariantAnimation.!

!AnimEasingCurve class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 14:29:14.198'!
linear

	^ self new
		type: #linear! !

!AnimEasingCurve methodsFor: 'accessing' stamp: 'mt 5/2/2011 20:19:17.89'!
conversionBlock

	^ conversionBlock! !

!AnimEasingCurve methodsFor: 'accessing' stamp: 'mt 5/2/2011 20:19:24.179'!
conversionBlock: aBlock

	conversionBlock := aBlock.! !

!AnimEasingCurve methodsFor: 'testing' stamp: 'mt 5/14/2010 19:29:07.001'!
isLinear

	^ self type = #linear! !

!AnimEasingCurve methodsFor: 'accessing' stamp: 'mt 5/14/2010 14:27:27.368'!
type

	^ type ifNil: [type := #linear]! !

!AnimEasingCurve methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 19:29:25.902'!
type: aType
	"Possible values: #linear."
	
	type := aType.! !

!AnimEasingCurve methodsFor: 'accessing' stamp: 'mt 5/2/2011 20:19:40.876'!
valueForProgress: aFloat
	"Interpolate the given value which should be between 0.0 and 1.0."
	
	^ self conversionBlock
		ifNil: [aFloat "just linear now"]
		ifNotNil: [:b | b value: aFloat]! !

Object subclass: #AnimSignalSpy
	instanceVariableNames: 'object signals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animations-Tests'!

!AnimSignalSpy commentStamp: 'mt 5/14/2010 11:09:41.178' prior: 0!
I am a support class to test the Squeak changed/update mechanism. Should only be used within one thread/process.!

!AnimSignalSpy class methodsFor: 'instance creation' stamp: 'mt 5/14/2010 11:07:44.811'!
on: anObject

	^ self new
		object: anObject! !

!AnimSignalSpy methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:12:02.191'!
lastArguments

	self signals ifEmpty: [Error signal: 'No signals were caught.'].
	^ self signals last second! !

!AnimSignalSpy methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:11:29.309'!
lastSignal

	self signals ifEmpty: [Error signal: 'No signals were caught.'].
	^ self signals last first! !

!AnimSignalSpy methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:11:42.717'!
lastSignalWithArguments

	self signals ifEmpty: [Error signal: 'No signals were caught.'].
	^ self signals last! !

!AnimSignalSpy methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:05:57.559'!
object

	^ object! !

!AnimSignalSpy methodsFor: 'accessing - private' stamp: 'mt 5/14/2010 11:07:25.5'!
object: anObject

	object := anObject.
	object addDependent: self.! !

!AnimSignalSpy methodsFor: 'accessing' stamp: 'mt 5/14/2010 11:06:30.624'!
signals

	^ signals ifNil: [signals := OrderedCollection new]! !

!AnimSignalSpy methodsFor: 'spying' stamp: 'mt 5/14/2010 11:25:24.605'!
update: aSignal

	self signals add: {aSignal. nil}.! !

!AnimSignalSpy methodsFor: 'spying' stamp: 'mt 5/14/2010 11:25:43.285'!
update: aSignal with: oneOrMoreArguments

	self signals add: {aSignal. oneOrMoreArguments}.! !
